Learn Tech Skills from Scratch @ Scaler EDGE

- Courses
- Programming
- Dynamic Programming
- Dynamic Programming Examples

Question : Calculate the nth fibonacci number.

Lets explore the steps to coming up with DP solution :

1) Think of a recursive approach to solving the problem.

This part is simple.

We already know

`fibo(n) = fibo(n - 1) + fibo(n - 2)`

and we satisfy the condition of `Yi < X`

as

`n - 1 < n`

and `n - 2 < n`

.

2) Write a recursive code for the approach you just thought of.

```
int fibo(int n) {
if (n <= 1) return n;
return fibo(n - 1) + fibo(n - 2);
}
```

Try to think of the time complexity of the above function.

We analyzed it previously in one of the lessons on recursion. You can check it out again.

It is essentially exponential in terms of n.

3) Save the results you get for every function run so that if `solve(A1, A2, A3, ... )`

is called again, you do not recompute the whole thing.

Ok. So, we try to save the value we calculate somewhere so that we dont compute it again. This is also called memoization.

Lets declare a global variable then.

```
int memo[100] = {0};
int fibo(int n) {
if (n <= 1) return n;
// If we have processed this function before, return the result from the last time.
if (memo[n] != 0) return memo[n];
// Otherwise calculate the result and remember it.
memo[n] = fibo(n - 1) + fibo(n - 2);
return memo[n];
}
```

4) Analyze the space and time requirements, and improve it if possible.

Lets look at the space complexity first. We have an array of size n allocated for storing the results which has space complexity of O(n).

We also have the stack memory overhead of recursion which is also O(n). So, overall space complexity is O(n).

Lets now look at the time complexity.

Lets look at fibo(n).

**Note: ** When fibo(n - 1) is called, it makes a call to fibo(n - 2). So when the call comes back to the original call from fibo(n), fibo(n-2) would already be calculated. Hence the call to fibo(n - 2) will be O(1).

```
Hence, T(n) = T(n - 1) + c where c is a constant.
= T(n - 2) + 2c
= T(n - 3) + 3c
= T(n - k) + kc
= T(0) + n * c = 1 + n * c = O(n).
```

And voila indeed! Thanks to DP, we reduced a exponential problem to a linear problem.

- Scaler Academy Review
- System Design Interview Questions
- Google Interview Questions
- Facebook Interview Questions
- Amazon Interview Questions
- Microsoft Interview Questions
- SQL Interview Questions
- Python Interview Questions
- Javascript Interview Questions
- MVC Interview Questions
- React Interview Questions
- Angular Interview Questions
- Directi Interview Questions
- Yahoo Interview Questions
- LinkedIn Interview Questions
- VMware Interview Questions
- eBay Interview Questions
- Flipkart Interview Questions

Log In using

or